//game.h

#ifndef GAME_H
#define GAME_H

enum GameStateEnum
{
	gs_TITLE=0,
	gs_MENU,
	gs_PLAY,
	gs_LEVEL_TRANSITION,
	gs_WIN,
	gs_DIE,
	gs_RESTARTING
};

class GameClass
{
public:
	GameStateEnum curState;
	PlayerClass player;
	MapClass map[5];
	int mapIndex;
	sf::VideoMode vid;
	sf::RenderWindow app;
	sf::View camera;
	sf::View hud;
	sf::String hudText;
	sf::Image theImage;
	sf::Event theEvent;
	sf::Image background;
	sf::Sprite bkSprite;
	sf::SoundBuffer feyTricks;
	sf::SoundBuffer clockSaver;
	sf::Sound themeSong;
	int storyBoard;
	bool quit;
	sf::FloatRect camport;
	MobClass mob[10];
	SecondsClass seconds[10];
	sf::Clock transitionClock;
	sf::Clock frameClock;

	GameClass();
	~GameClass() {}

	void init();
	void setState(GameStateEnum newState);
	bool isState(GameStateEnum test);

	void theLoop();
	

};

#endif //GAME_H