//map.h

#ifndef MAP_H
#define MAP_H

#define tl_GRASS 8
#define tl_FLOOR 9
#define tl_AIR 10

#define TILES_ON_MAP 16*9

struct MapTileStruct
{
	bool isSolid;
	bool isMobBumper;
	bool isPortal;
	bool isLethal;
	bool isGravity;
	sf::Vector2f vel;
	sf::Vector2f pos;
	int tileID;
	MapTileStruct() {isSolid=false; isPortal=false; isLethal=false; isGravity=false; isMobBumper=false; vel=sf::Vector2f(0,0); pos=sf::Vector2f(0,0); tileID=0;}
};


class MapClass
{
public:
	MapClass();
	~MapClass() {}

	MapTileStruct tile[TILES_ON_MAP];
	sf::Vector2f startPoint;
	sf::Vector2f mobPoint[10];
	int mobStyle[10];

	void initMap(const char* mapfile);
	void setTile(int index, bool isS, bool isL, bool isG, int id);
	void setTile(int xx, int yy, bool isS, bool isL, bool isG, int id);
	void setVelocity(int index, sf::Vector2f nv);
	void setVelocity(int xx, int yy, sf::Vector2f nv);
	void setGravity(int index, bool val);
	void setGravity(int xx, int yy, bool val);

	sf::IntRect getBoundingTile(int index);

	void update();
	void render(sf::RenderWindow& win);

};

#endif//MAP_H