//player.h
#ifndef PLAYER_H
#define PLAYER_H

class PlayerClass
{
public:
	PlayerClass();
	~PlayerClass() {}

	sf::Vector2f pos;
	sf::Vector2f vel;
	sf::Sprite frame;
	int collected;
	bool isLeft;
	bool isJumping;
	bool isFalling;
	int jumptime;
	int maxjump;
	sf::Clock attackClock;
	sf::Clock deathClock;
	sf::SoundBuffer kaching;
	sf::Sound coinSound;
	bool isAttacking;
	bool isDead;
	bool isAscended;

	sf::IntRect getBoundingBox();
	sf::IntRect getAttackBox();

	void init();
	void loadFrame(sf::Image& img, int index); //assumes 32x32 tiles only
	void render(sf::RenderWindow& win, sf::Image& spritesheet);
	void setLeft(bool val) {isLeft=val;}

	void update(MapClass& m, MobClass* enemyPtr, SecondsClass* secPtr);
};

#endif//PLAYER_H