//mob.cpp
#include "globals.h"

sf::IntRect SecondsClass::getBoundingBox()
{
	return sf::IntRect(int(pos.x)+9, int(pos.y)+9, int(pos.x)+28, int(pos.y)+28);
}

SecondsClass::SecondsClass()
{
	pos=sf::Vector2f(0,0);
	vel=sf::Vector2f(0,0);
	sf::Image im;
	im.LoadFromFile("images/spritesheet.png");
	im.SetSmooth(false);
	loadFrame(im, 3);
	isFalling=true;
	isActive=false;
}

void SecondsClass::loadFrame(sf::Image& img, int index)
{
	//split index into x/y coords based on an 8x8 sheet of 32x32 tiles
	//starting from top left corner '0' -> (0,0)
	int xx=index%8;
	int yy=int(index/8);
	sf::IntRect r(xx*32, yy*32, (xx+1)*32, (yy+1)*32);
	frame.SetImage(img);
	frame.SetSubRect(r);
}

void SecondsClass::render(sf::RenderWindow& win, sf::Image& spritesheet)
{
	if(isActive)
	{
		frame.SetPosition(pos);
		win.Draw(frame);
	}
}

void SecondsClass::update(MapClass& m)
{
	if(isActive)
	{
		if(vel.x>0.0f)
		{
			if(vel.x<0.2f) vel.x=0.0f;
			else vel.x-=0.2f;
		}
		if(vel.x>3.6f) vel.x=3.6f;

		if(vel.x<0.0f)
		{
			if(vel.x>-0.2f) vel.x=0.0f;
			else vel.x+=0.2f;
		}
		if(vel.x<-3.6f) vel.x=-3.6f;
		pos.x+=vel.x;
	
		for(int i=0; i<TILES_ON_MAP; i++)
		{
			if(getBoundingBox().Intersects(m.getBoundingTile(i)) || !getBoundingBox().Intersects(sf::IntRect(16,16,(32*16)-16, (32*9)-16)))
			{
				if(m.tile[i].isSolid)
				{
					pos.x-=vel.x;
					vel.x=-vel.x;
					break;
				}
			}
		}

		if(isFalling)
		{
			vel.y+=1.1f;
		}

		if(vel.y>4.7f) vel.y=4.7f;

		pos.y+=vel.y;
		for(int i=0; i<TILES_ON_MAP; i++)
		{
			if(getBoundingBox().Intersects(m.getBoundingTile(i)) || !getBoundingBox().Intersects(sf::IntRect(16,16,32*16, 32*9)))
			{
				if(m.tile[i].isSolid)
				{
					if(vel.y>0.0f)
					{
						pos.y-=vel.y;
						vel.y=0.0f;
						isFalling=false;
					}
					else if(vel.y<0.0f)
					{
						pos.y-=vel.y;
						vel.y=0.0f;
						isFalling=true;
					}
				}
			}
		}
	}
	frame.SetPosition(pos);

}